/*
 * cached_sequence_index.h
 *
 *  Created on: 2012/03/01
 *      Author: shu
 */

#ifndef CACHED_SA_SEQUENCE_INDEX_H_
#define CACHED_SA_SEQUENCE_INDEX_H_


#include <fstream>
#include "sequence_index.h"
#include "suffix_array.h"

class Encoder;

class CachedSaSequenceIndex : public SequenceIndex {
public:
  CachedSaSequenceIndex(const unsigned char *text, unsigned int length, unsigned int max_cached_offset, const Encoder &encoder);
  CachedSaSequenceIndex(std::ifstream &is);
  virtual  ~CachedSaSequenceIndex();
  void Search(unsigned int offset, unsigned int start, unsigned int end, unsigned char *start_character, unsigned char *end_character,
      unsigned int *start_list, unsigned int *end_list);
  unsigned int Locate(unsigned int position);
  unsigned int GetMaxAlphabet();

  void Load(std::ifstream &is);
  void Save(std::ofstream &os);

private:
  void SetKeyShiftSize(unsigned char max_character);
  unsigned int GetKey(unsigned int position, unsigned int lenght) ;
  void SetCache(unsigned int max_cached_offset, unsigned char max_character);

  SuffixArray sa_;
  unsigned int max_cached_offset_;
  unsigned char max_character_;
  unsigned int key_shift_size_;
  std::vector< std::vector<unsigned int> >cached_starts_;
  std::vector< std::vector<unsigned int> >cached_ends_;

};

#endif /* CACHED_SA_SEQUENCE_INDEX_H_ */
