/*
 * chain_filter.h
 *
 *  Created on: 2011/01/27
 *      Author: shu
 */

#ifndef CHAIN_FILTER_H_
#define CHAIN_FILTER_H_

#include "aligner.h"
#include "encoder.h"
#include "aligner_parameters.h"
#include <vector>

class Query;
class DB;

class ChainFilter {
public:
  ChainFilter(const AlignerParameters &parameters);
  void Filter(Query &query, Db &db, std::vector<Hit> &hits);

private:
  typedef struct {
    uint32_t query_end;
    uint32_t diagonal;
  }Chain;

  class DbStartComp {
  public:
    bool operator()(const Hit &a1, const Hit &a2) const {
      return a1.start.db_offset <  a2.start.db_offset;
    }
  };

  bool Connected(Query &query, Db &db, uint32_t chain_query_end, Hit &hit, int cutoff);

  AlignerParameters parameters_;
  std::vector<Chain> chains_;
};


#endif /* CHAIN_FILTER_H_ */
