/*
 * edit_array.h
 *
 *  Created on: 2010/11/28
 *      Author: shu
 */

#ifndef EDIT_BLOCKS_H_
#define EDIT_BLOCKS_H_

#include <vector>

class EditBlocks {
public:
  enum EditOpType{
    kDeletion,
    kSubstitution,
    kInsertion
  };

  typedef struct {
    EditOpType op;
    int length;
  }Block;

  void Clear();
  void Add(EditBlocks::EditOpType op_type , int length);
  void Add(EditBlocks other);
  void Reverse();
  size_t Length() {
	  return blocks_.size();
  }
  std::vector<EditBlocks::EditOpType> ToVector();

private:
  std::vector<Block> blocks_;
};

#endif /* EDIT_ARRAY_H_ */
