/*
 * encoder.h
 *
 *  Created on: 2010/09/12
 *      Author: shu
 */

#ifndef ENCODER_H_
#define ENCODER_H_

#include <string>
#include <limits.h>

typedef unsigned char Code;

class SequenceType;
class Sequence;

class Encoder {
public:
  Encoder(const SequenceType &type);

  Code Encode (char letter) const ;

  void Encode (const std::string &sequence_data,  Code *encoded_sequence) const ;

  bool IsUnknown(char letter) const ;

  Code GetMinRegularLetterCode() const  {
    return min_regular_letter_code_;
  }

  Code GetMaxRegularLetterCode() const  {
    return max_regular_letter_code_;
  }

  Code GetMinCode() const  {
    return min_code_;
  }

  Code GetMaxCode() const  {
    return max_code_;
  }

  Code GetUnknownCode() const  {
    return unknown_code_;
  }



private:
  struct ToUpper {
      char operator()(char c) { return toupper(c); }
  };
  Code min_regular_letter_code_;
  Code max_regular_letter_code_;
  Code min_code_;
  Code max_code_;
  Code codes_[UCHAR_MAX];
  Code unknown_code_;
  char unknown_letter;
};

#endif /* ENCODER_H_ */
