/*
 * sa_index.h
 *
 *  Created on: 2011/02/21
 *      Author: shu
 */

#ifndef SA_INDEX_H_
#define SA_INDEX_H_

#include <fstream>
#include "sequence_index.h"
#include "suffix_array.h"

class Encoder;

class SaSequenceIndex : public SequenceIndex {
public:
  SaSequenceIndex(const unsigned char *text, unsigned int length, const Encoder &encoder);
  SaSequenceIndex(std::ifstream &is);
  virtual  ~SaSequenceIndex();
  void Search(unsigned int offset, unsigned int start, unsigned int end, unsigned char *start_character, unsigned char *end_character,
      unsigned int *start_list, unsigned int *end_list);
  unsigned int Locate(unsigned int position);
  unsigned int GetMaxAlphabet();

  void Load(std::ifstream &is);
  void Save(std::ofstream &os);

private:
  SuffixArray sa_;
};

#endif /* SA_INDEX_H_ */
