/*
 * score_matrix.h
 *
 *  Created on: 2010/04/22
 *      Author: shu
 */

#ifndef SCORE_MATRIX_H_
#define SCORE_MATRIX_H_

#include <stdint.h>
#include <string>
#include <vector>

class Encoder;

class ScoreMatrix {
public:
  ScoreMatrix();
  ScoreMatrix(const std::string &name, const Encoder &encoder, int match, int mismatch);
  ScoreMatrix(std::string name, int *matrix, uint32_t number_letters);
  virtual ~ScoreMatrix() {}

  std::string GetName() const {
    return name_;
  }

  const std::vector<int>& GetMatrix() const {
    return matrix_;
  }

  int GetHighestValue() const {
    return highest_value_;
  }

  int GetLowestValue() const {
    return lowest_value_;
  }

  uint32_t GetNumberLetters() const {
    return number_letters_;
  }

private:
  std::string name_;
  std::vector<int> matrix_;
  int highest_value_;
  int lowest_value_;
  uint32_t number_letters_;
};

#endif /* SCORE_MATRIX_H_ */
