/*
 * score_matrix_reader.h
 *
 *  Created on: 2010/06/22
 *      Author: shu
 */

#ifndef SCORE_MATRIX_READER_H_
#define SCORE_MATRIX_READER_H_

#include <fstream>
#include <string>
#include <iostream>
#include <fstream>
#include <list>
#include "encoder.h"

class ScoreMatrix;

class ScoreMatrixReader {
public:
  ScoreMatrixReader(const Encoder &encoder);

  virtual ~ScoreMatrixReader();

  ScoreMatrix Read(const std::string &filename);
  ScoreMatrix ReadDefault();

private:
  static const std::string default_matrix_;
  static const std::string default_matrix_name_;

  std::list<std::string> Split(std::string str, std::string delim);
  int GetNumberLetters();
  int GetMatrixSize();
  void Parse(std::istream &in, int *matrix);
  std::string GetName(const std::string &filename);

  Encoder encoder_;
};

#endif /* SCORE_MATRIX_READER_H_ */
