/*
 * suffix_array.h
 *
 *  Created on: 2010/08/02
 *      Author: shu
 */

#ifndef SUFFIX_ARRAY_H_
#define SUFFIX_ARRAY_H_

#include <vector>
#include <iostream>
#include <fstream>

class SuffixArray {
public:
  SuffixArray();
  SuffixArray(const unsigned char *text, unsigned int length);
  SuffixArray(std::ifstream &is);
  void Rebuild(const unsigned char *text, unsigned int length);
  void Search(unsigned char character, unsigned int offset, unsigned int *start, unsigned int *end);
  void Search(unsigned int offset, unsigned int start, unsigned int end, unsigned char *start_character, unsigned char *end_character, unsigned int *start_list, unsigned int *end_list);
  unsigned int Locate(unsigned int i);

  const unsigned char* GetText() {
    return &text_[0];
  }

  unsigned int GetTextSize() {
    return text_.size();
  }

  unsigned char GetMaxAlphabet() {
    return max_alphabet_;
  }


  void Load(std::ifstream &is);
  void Save(std::ofstream &os);

private:
  unsigned char max_alphabet_;
  std::vector<unsigned char> text_;
  std::vector<unsigned int> suffix_array_;

};

#endif /* SUFFIX_ARRAY_H_ */
